# tsviewer **[WIP]**

A TS3 Viewer with REST API.

## DOCKER-Config

```bash
docker build -t name/cont:ver .

docker run -e ts3_ip="ts_ip", ts3_pw="quarry_pw", web_port="port" -d -p 8080:8080 name/cont:ver
```
ENV:
```Docker

ENV ts3_ip=0.0.0.0
ENV ts3_name=serveradmin
ENV ts3_pw=f3gWdOU3
ENV ts3_port=9987
ENV ts3_query=10011
ENV web_port=8080

```

# Features

## Config

The config file is generated automatically on first startup.
```json
{
    "user": {
        "name": "serveradmin",
        "password": ""
    },
    "serverTS": {
        "ip": "127.0.0.1",
        "portServer": 9987,
        "portQuery": 10011
    },
    "serverWeb": {
        "port": 80
    }
}
```

## URL-Parameter

| Name       | Type     | Description              |
| ---------- | -------- | ------------------------ |
| `pretty`   | `bool`   | pretty-prints JSON       |
| `envelope` | `bool`   | wraps JSON in data array |

## Channels

- **`GET`** `/v1/channels/:id`
- **`GET`** `/v1/channels`
```json
{
    "databaseId": 1,
    "channelId": 1,
    "nickname": "serveradmin from 127.0.0.1:58359",
    "type": 1,
    "away": false,
    "awayMessage": ""
}
```

## Clients

- **`GET`** `/v1/clients/:id`
- **`GET`** `/v1/clients/`
```json
{
    "id": 1,
    "subchannels": [
        ... (contains all subchannel)
    ],
    "name": "main1",
    "totalClients": 0,
    "neededSubscribePower": 0
}
```

## Server

- **`GET`** `/v1/server/info`
```json
{
    "name": "TeamSpeak ]I[ Server",
    "status": "online",
    "version": "3.5.1 [Build: 1545076855]",
    "welcomeMessage": "Welcome to TeamSpeak, check [URL]www.teamspeak.com[/URL] for latest information",
    "maxClients": 32,
    "clientsOnline": 2,
    "reservedSlots": 0,
    "uptime": 5976,
    "totalPing": 0,
    "minAndroidVersion": 1502275280,
    "minClientVersion": 1513163251,
    "miniOSVersion": 1502275280
}
```
